\chapter{Hardware Implementation \label{chap:Implementation}}


To verify the algorithms discussed in the previous chapters on an actual \gls{pmsm}, suitable commercially available platform was chosen.
However, due to struggles with the hardware implementation, only field-oriented \gls{pi} controller and one-step \gls{fcsmpc} were put into operation.
Thus, the experimental evaluation is not provided and only general notes are given in this chapter.




\section{Selected Hardware Platform}
For hardware implementation, AD-FMCMOTCON2-EBZ driver by Analog devices together with ZedBoard was chosen.
AD-FMCMOTCON2-EBZ is a driver system allowing control of two motors simultaneously.
It contains sigma-delta modulators for measuring the phase currents with 16-bit resolution at \SI{78.1}{\kilo\hertz}.
To measure at higher frequency, the resolution has to be decreased by decreasing decimation ration of demodulating filters.
ZedBoard is a prototyping platform with Zynq-7000 \gls{soc}, which contains ARM$^{\circledR}$  dual  Cortex$^{\circledR}$-A9 and Xilinx 7-series \gls{fpga} fabric on a single chip.
Both the ARM$^{\circledR}$ processing system  and \gls{fpga} fabric are supported by MATLAB and Simulink, and one can relatively easily implement co-designs both parts of the chip.
A photograph of the platform is shown in fig. \ref{fig:HardwarePlatform}.

% Figure
\begin{figure}[t]
	\begin{center}
		\includegraphics[width=0.65\textwidth]{figs/foto/foto.jpg}
		\caption{ZedBoard and AD-FMCMOTCON2-EBZ with two coupled \glspl{pmsm}.  \label{fig:HardwarePlatform}}
	\end{center}
\end{figure}



\section{Bootstrap Circuit Limitations}
One drawback of AD-FMCMOTCON2-EBZ driver is that uses bootstrap circuits to power the high-side switches.
The board uses n-channel MOSFETs, which are switched when positive voltage is applied between the gate and source.
When high-side MOSFET is switched, its source is connected to the \gls{dc}-bus voltage and it is necessary to have voltage above this level to keep the switch on.
One possibility is to use a bootstrap capacitor which is charged when the high-side MOSFET is off and the low-side MOSFET on, and provides sufficient voltage level when it is the other way around.
However, the bootstrap capacitor gets discharged after some time (typically a few milliseconds) when the high-side MOSFET is kept on.
This limits the maximum admissible duty cycle when a modulation stage is used.
In principle, \gls{fcsmpc} may keep the high-side switches on indefinitely and the bootstrap capacitor should be taken into account.
A very simple but not efficient solution is to override the controller switching sequence when a high-side MOSFET is on for too long \cite{LinderBook}.


To avoid problems with the bootstrap capacitor, an attempt was to modify AD-FMCMOTCON2-EBZ driver by adding charge pumps, which would allow the high-side switches to be on indefinitely.
However, the output voltages of the charge pumps dropped significantly when loaded and this solution did not work.


\section{Delay Compensation}

As the \gls{mpc} algorithms are computationally demanding and it takes some time to obtain the result of the optimization problem, delay compensation should be implemented.
A simple method is presented in \cite{computationally demanding}.
The idea is to delay the control input and apply it at the beginning of the next sampling period.
The controller then uses state predicted for the next step instead of the current state.

